Initial commit

This commit is contained in:
Silvan Calarco 2011-05-04 02:30:35 +02:00
commit 4ffd3c128d
23 changed files with 3981 additions and 0 deletions

152
ChangeLog Normal file
View File

@ -0,0 +1,152 @@
2011-03-08 2.3 Silvan Calarco <silvan.calarco@mambasoft.it>
* sync at milestone2 2.0pre4 release date
* remove obsoleted files
2010-05-01 2.2.0 Silvan Calarco <silvan.calarco@mambasoft.it>
* lots of changes for cross platform support
* added support for vector defined repositories braking the previous limit of 4 maximum
2009-04-03 2.1.1 Silvan Calarco <silvan.calarco@mambasoft.it>
* added support for extra repository
2009-01-25 2.1.0 Silvan Calarco <silvan.calarco@mambasoft.it>
* added support for cross-arch targets and BSP's
* added extract_source_packages and add_binary_packages_to_repository_nodeps functions
* mkisofs: enable joliet extensions
2008-02-03 2.0.9 Silvan Calarco <silvan.calarco@mambasoft.it>
* functions.inc.sh:
- added funtions add_binary_packages_to_repositories
2007-08-09 2.0.8 Silvan Calarco <silvan.calarco@mambasoft.it>
* functions.inc.sh:
- added functions resolve_pkg_deps and add_packages_to_repositories
* deps.inc.sh:
- removed final "/" in auto-generated distromatic.conf rep dirs
* added language support with LANGUAGE variable
* CDDIR replaced by MOUNTDIR2
* dropped initrd directory
* a lot of old code cleanup
2007-07-04 2.0.7 Silvan Calarco <silvan.calarco@mambasoft.it>
* functions.inc.sh: added the following functions:
- expand_srpm_names
- exec_distromatic
- get_pkg_buildinfo
- add_installed_packages_to_repository
* minor fixes and some obsolete code cleanup
* interface appearance changes
2007-06-30 2.0.6 Silvan Calarco <silvan.calarco@mambasoft.it>
* Makefile: moved make deps and deps-rpm from file to a newly created
installation Mafefile
* Makefile: some obsolete code cleanup and added warning about not using
this file directly by the user
* defs.inc.sh: don't configure alternate repository if PREFERRED_REPOSITORY
is not defined
2007-06-30 2.0.5 Silvan Calarco <silvan.calarco@mambasoft.it>
* makedist: added support for raw filesystem and disk image
* makedist: added function media_name that defines the final target name
* defs.inc.sh: create files distromatic.conf and .defs.inc in /var/makedist
* defs.inc.sh: add support for config-$TARGET and config-$TARGET-$PLATFORM
configuration files
2007-05-28 2.0.4 Silvan Calarco <silvan.calarco@mambasoft.it>
* makedist: added VERBOSE and DISTROMATIC[=off] options
* global/Makefile.globdefs: cleanup of old definitions
2007-03-09 2.0.3 Silvan Calarco <silvan.calarco@mambasoft.it>
* added internal distromatic support
* support for platform level Makefile and Makefile.defs
* many small improvements
2007-02-12 2.0.2 Silvan Calarco <silvan.calarco@mambasoft.it>
* change default values for openmamba
* targets moved to localstate dir
* introduced new main level program makedist
2007-02-12 2.0.1 Silvan Calarco <silvan.calarco@mambasoft.it>
* move target specific files (Makefile, Makefile.defs) into target dirs
* move global makefiles into global dir
2007-01-29 2.0.0 Silvan Calarco <silvan.calarco@mambasoft.it>
* rename to makedist
2006-12-04 1.7.0 Silvan Calarco <silvan.calarco@mambasoft.it>
* first mamba linux port
2006-03-16 1.6.1 Davide Madrisan <davide.madrisan@qilinux.it>
* cvs sync
2006-03-10 1.6.0 Silvan Calarco <silvan.calarco@qilinux.it>
* added support for PLATFORM
* main distribution target renamed to qilinux
* qilinux target: support for custom release files
* lots of fixes and improvements
2006-01-23 1.5.1 Silvan Calarco <silvan.calarco@qilinux.it>
* added support for MEDIA makefile variable
* many fixes and improvements
2006-01-11 1.5.0 Silvan Calarco <silvan.calarco@qilinux.it>
* added qemu scripts for tests
* added desktop target (QiLinux 2) with many fixes
2005-11-25 1.3.1 Silvan Calarco <silvan.calarco@qilinux.it>
* liveedu target for QiLinux Docet livecd
* lots of changes related to new livedu target
2005-09-21 1.3.0 Silvan Calarco <silvan.calarco@qilinux.it>
* multiarch support
* added embedded target
* many more fixes and changes
2005-06-22 1.2.10 Silvan Calarco <silvan.calarco@qilinux.it>
* added support for updates branch if present (use updated packages)
* fixed usb device boot support
* fixed configuration for a missing floppy machine
* added a lot of SCSI drivers
2005-01-12 1.2.8 Silvan Calarco <silvan.calarco@qilinux.it>
* removed utils.inc (trash)
* first CVS imported release
2005-01-12 1.2.7 Silvan Calarco <silvan.calarco@qilinux.it>
* moved functions to functions.inc.sh
* lots of fixes towards QiLinux 1.2 release
2004-12-29 1.2.6 Silvan Calarco <silvan.calarco@qilinux.it>
* a lot of small fixes/modifications for livecd 1.1
2004-11-14 1.2.5 Silvan Calarco <silvan.calarco@qilinux.it>
* added target dir with files for different targets
* isolinux dir is under specific target dir
2004-11-08 1.2.4 Silvan Calarco <silvan.calarco@qilinux.it>
* fixes for LiveCD
* support for USB external CDROMs
2004-08-11 1.2.3 Silvan Calarco <silvan.calarco@qilinux.it>
* fixes for QiLinux 1.1 distrocds and livecd
2004-08-11 1.2.2 Silvan Calarco <silvan.calarco@qilinux.it>
* ISOLINUX: updated to 2.10 and added help and italian translation
2004-08-11 1.2.1 Silvan Calarco <silvan.calarco@qilinux.it>
* install and boot from both 2.4 and 2.6 kernels
* a lot of small changes
2004-08-03 1.2.0 Silvan Calarco <silvan.calarco@qilinux.it>
* package installation now based on Makefile with automatic dependencies check
* added new livecd target
2004-07-26 1.1.11 Davide Madrisan <davide.madrisan@qilinux.it>
* check for cp errors (missing files) while creating CDs
2004-07-21 1.1.10 Silvan Calarco <silvan.calarco@qilinux.it>
* removed colors and some cleaning from linuxrc script (a Knopping legacy)
2004-07-19 1.1.9 Silvan Calarco <silvan.calarco@qilinux.it>
* raidtools package added to live CD
* created ChangeLog

674
LICENSE Normal file
View File

@ -0,0 +1,674 @@
GNU GENERAL PUBLIC LICENSE
Version 3, 29 June 2007
Copyright (C) 2007 Free Software Foundation, Inc. <http://fsf.org/>
Everyone is permitted to copy and distribute verbatim copies
of this license document, but changing it is not allowed.
Preamble
The GNU General Public License is a free, copyleft license for
software and other kinds of works.
The licenses for most software and other practical works are designed
to take away your freedom to share and change the works. By contrast,
the GNU General Public License is intended to guarantee your freedom to
share and change all versions of a program--to make sure it remains free
software for all its users. We, the Free Software Foundation, use the
GNU General Public License for most of our software; it applies also to
any other work released this way by its authors. You can apply it to
your programs, too.
When we speak of free software, we are referring to freedom, not
price. Our General Public Licenses are designed to make sure that you
have the freedom to distribute copies of free software (and charge for
them if you wish), that you receive source code or can get it if you
want it, that you can change the software or use pieces of it in new
free programs, and that you know you can do these things.
To protect your rights, we need to prevent others from denying you
these rights or asking you to surrender the rights. Therefore, you have
certain responsibilities if you distribute copies of the software, or if
you modify it: responsibilities to respect the freedom of others.
For example, if you distribute copies of such a program, whether
gratis or for a fee, you must pass on to the recipients the same
freedoms that you received. You must make sure that they, too, receive
or can get the source code. And you must show them these terms so they
know their rights.
Developers that use the GNU GPL protect your rights with two steps:
(1) assert copyright on the software, and (2) offer you this License
giving you legal permission to copy, distribute and/or modify it.
For the developers' and authors' protection, the GPL clearly explains
that there is no warranty for this free software. For both users' and
authors' sake, the GPL requires that modified versions be marked as
changed, so that their problems will not be attributed erroneously to
authors of previous versions.
Some devices are designed to deny users access to install or run
modified versions of the software inside them, although the manufacturer
can do so. This is fundamentally incompatible with the aim of
protecting users' freedom to change the software. The systematic
pattern of such abuse occurs in the area of products for individuals to
use, which is precisely where it is most unacceptable. Therefore, we
have designed this version of the GPL to prohibit the practice for those
products. If such problems arise substantially in other domains, we
stand ready to extend this provision to those domains in future versions
of the GPL, as needed to protect the freedom of users.
Finally, every program is threatened constantly by software patents.
States should not allow patents to restrict development and use of
software on general-purpose computers, but in those that do, we wish to
avoid the special danger that patents applied to a free program could
make it effectively proprietary. To prevent this, the GPL assures that
patents cannot be used to render the program non-free.
The precise terms and conditions for copying, distribution and
modification follow.
TERMS AND CONDITIONS
0. Definitions.
"This License" refers to version 3 of the GNU General Public License.
"Copyright" also means copyright-like laws that apply to other kinds of
works, such as semiconductor masks.
"The Program" refers to any copyrightable work licensed under this
License. Each licensee is addressed as "you". "Licensees" and
"recipients" may be individuals or organizations.
To "modify" a work means to copy from or adapt all or part of the work
in a fashion requiring copyright permission, other than the making of an
exact copy. The resulting work is called a "modified version" of the
earlier work or a work "based on" the earlier work.
A "covered work" means either the unmodified Program or a work based
on the Program.
To "propagate" a work means to do anything with it that, without
permission, would make you directly or secondarily liable for
infringement under applicable copyright law, except executing it on a
computer or modifying a private copy. Propagation includes copying,
distribution (with or without modification), making available to the
public, and in some countries other activities as well.
To "convey" a work means any kind of propagation that enables other
parties to make or receive copies. Mere interaction with a user through
a computer network, with no transfer of a copy, is not conveying.
An interactive user interface displays "Appropriate Legal Notices"
to the extent that it includes a convenient and prominently visible
feature that (1) displays an appropriate copyright notice, and (2)
tells the user that there is no warranty for the work (except to the
extent that warranties are provided), that licensees may convey the
work under this License, and how to view a copy of this License. If
the interface presents a list of user commands or options, such as a
menu, a prominent item in the list meets this criterion.
1. Source Code.
The "source code" for a work means the preferred form of the work
for making modifications to it. "Object code" means any non-source
form of a work.
A "Standard Interface" means an interface that either is an official
standard defined by a recognized standards body, or, in the case of
interfaces specified for a particular programming language, one that
is widely used among developers working in that language.
The "System Libraries" of an executable work include anything, other
than the work as a whole, that (a) is included in the normal form of
packaging a Major Component, but which is not part of that Major
Component, and (b) serves only to enable use of the work with that
Major Component, or to implement a Standard Interface for which an
implementation is available to the public in source code form. A
"Major Component", in this context, means a major essential component
(kernel, window system, and so on) of the specific operating system
(if any) on which the executable work runs, or a compiler used to
produce the work, or an object code interpreter used to run it.
The "Corresponding Source" for a work in object code form means all
the source code needed to generate, install, and (for an executable
work) run the object code and to modify the work, including scripts to
control those activities. However, it does not include the work's
System Libraries, or general-purpose tools or generally available free
programs which are used unmodified in performing those activities but
which are not part of the work. For example, Corresponding Source
includes interface definition files associated with source files for
the work, and the source code for shared libraries and dynamically
linked subprograms that the work is specifically designed to require,
such as by intimate data communication or control flow between those
subprograms and other parts of the work.
The Corresponding Source need not include anything that users
can regenerate automatically from other parts of the Corresponding
Source.
The Corresponding Source for a work in source code form is that
same work.
2. Basic Permissions.
All rights granted under this License are granted for the term of
copyright on the Program, and are irrevocable provided the stated
conditions are met. This License explicitly affirms your unlimited
permission to run the unmodified Program. The output from running a
covered work is covered by this License only if the output, given its
content, constitutes a covered work. This License acknowledges your
rights of fair use or other equivalent, as provided by copyright law.
You may make, run and propagate covered works that you do not
convey, without conditions so long as your license otherwise remains
in force. You may convey covered works to others for the sole purpose
of having them make modifications exclusively for you, or provide you
with facilities for running those works, provided that you comply with
the terms of this License in conveying all material for which you do
not control copyright. Those thus making or running the covered works
for you must do so exclusively on your behalf, under your direction
and control, on terms that prohibit them from making any copies of
your copyrighted material outside their relationship with you.
Conveying under any other circumstances is permitted solely under
the conditions stated below. Sublicensing is not allowed; section 10
makes it unnecessary.
3. Protecting Users' Legal Rights From Anti-Circumvention Law.
No covered work shall be deemed part of an effective technological
measure under any applicable law fulfilling obligations under article
11 of the WIPO copyright treaty adopted on 20 December 1996, or
similar laws prohibiting or restricting circumvention of such
measures.
When you convey a covered work, you waive any legal power to forbid
circumvention of technological measures to the extent such circumvention
is effected by exercising rights under this License with respect to
the covered work, and you disclaim any intention to limit operation or
modification of the work as a means of enforcing, against the work's
users, your or third parties' legal rights to forbid circumvention of
technological measures.
4. Conveying Verbatim Copies.
You may convey verbatim copies of the Program's source code as you
receive it, in any medium, provided that you conspicuously and
appropriately publish on each copy an appropriate copyright notice;
keep intact all notices stating that this License and any
non-permissive terms added in accord with section 7 apply to the code;
keep intact all notices of the absence of any warranty; and give all
recipients a copy of this License along with the Program.
You may charge any price or no price for each copy that you convey,
and you may offer support or warranty protection for a fee.
5. Conveying Modified Source Versions.
You may convey a work based on the Program, or the modifications to
produce it from the Program, in the form of source code under the
terms of section 4, provided that you also meet all of these conditions:
a) The work must carry prominent notices stating that you modified
it, and giving a relevant date.
b) The work must carry prominent notices stating that it is
released under this License and any conditions added under section
7. This requirement modifies the requirement in section 4 to
"keep intact all notices".
c) You must license the entire work, as a whole, under this
License to anyone who comes into possession of a copy. This
License will therefore apply, along with any applicable section 7
additional terms, to the whole of the work, and all its parts,
regardless of how they are packaged. This License gives no
permission to license the work in any other way, but it does not
invalidate such permission if you have separately received it.
d) If the work has interactive user interfaces, each must display
Appropriate Legal Notices; however, if the Program has interactive
interfaces that do not display Appropriate Legal Notices, your
work need not make them do so.
A compilation of a covered work with other separate and independent
works, which are not by their nature extensions of the covered work,
and which are not combined with it such as to form a larger program,
in or on a volume of a storage or distribution medium, is called an
"aggregate" if the compilation and its resulting copyright are not
used to limit the access or legal rights of the compilation's users
beyond what the individual works permit. Inclusion of a covered work
in an aggregate does not cause this License to apply to the other
parts of the aggregate.
6. Conveying Non-Source Forms.
You may convey a covered work in object code form under the terms
of sections 4 and 5, provided that you also convey the
machine-readable Corresponding Source under the terms of this License,
in one of these ways:
a) Convey the object code in, or embodied in, a physical product
(including a physical distribution medium), accompanied by the
Corresponding Source fixed on a durable physical medium
customarily used for software interchange.
b) Convey the object code in, or embodied in, a physical product
(including a physical distribution medium), accompanied by a
written offer, valid for at least three years and valid for as
long as you offer spare parts or customer support for that product
model, to give anyone who possesses the object code either (1) a
copy of the Corresponding Source for all the software in the
product that is covered by this License, on a durable physical
medium customarily used for software interchange, for a price no
more than your reasonable cost of physically performing this
conveying of source, or (2) access to copy the
Corresponding Source from a network server at no charge.
c) Convey individual copies of the object code with a copy of the
written offer to provide the Corresponding Source. This
alternative is allowed only occasionally and noncommercially, and
only if you received the object code with such an offer, in accord
with subsection 6b.
d) Convey the object code by offering access from a designated
place (gratis or for a charge), and offer equivalent access to the
Corresponding Source in the same way through the same place at no
further charge. You need not require recipients to copy the
Corresponding Source along with the object code. If the place to
copy the object code is a network server, the Corresponding Source
may be on a different server (operated by you or a third party)
that supports equivalent copying facilities, provided you maintain
clear directions next to the object code saying where to find the
Corresponding Source. Regardless of what server hosts the
Corresponding Source, you remain obligated to ensure that it is
available for as long as needed to satisfy these requirements.
e) Convey the object code using peer-to-peer transmission, provided
you inform other peers where the object code and Corresponding
Source of the work are being offered to the general public at no
charge under subsection 6d.
A separable portion of the object code, whose source code is excluded
from the Corresponding Source as a System Library, need not be
included in conveying the object code work.
A "User Product" is either (1) a "consumer product", which means any
tangible personal property which is normally used for personal, family,
or household purposes, or (2) anything designed or sold for incorporation
into a dwelling. In determining whether a product is a consumer product,
doubtful cases shall be resolved in favor of coverage. For a particular
product received by a particular user, "normally used" refers to a
typical or common use of that class of product, regardless of the status
of the particular user or of the way in which the particular user
actually uses, or expects or is expected to use, the product. A product
is a consumer product regardless of whether the product has substantial
commercial, industrial or non-consumer uses, unless such uses represent
the only significant mode of use of the product.
"Installation Information" for a User Product means any methods,
procedures, authorization keys, or other information required to install
and execute modified versions of a covered work in that User Product from
a modified version of its Corresponding Source. The information must
suffice to ensure that the continued functioning of the modified object
code is in no case prevented or interfered with solely because
modification has been made.
If you convey an object code work under this section in, or with, or
specifically for use in, a User Product, and the conveying occurs as
part of a transaction in which the right of possession and use of the
User Product is transferred to the recipient in perpetuity or for a
fixed term (regardless of how the transaction is characterized), the
Corresponding Source conveyed under this section must be accompanied
by the Installation Information. But this requirement does not apply
if neither you nor any third party retains the ability to install
modified object code on the User Product (for example, the work has
been installed in ROM).
The requirement to provide Installation Information does not include a
requirement to continue to provide support service, warranty, or updates
for a work that has been modified or installed by the recipient, or for
the User Product in which it has been modified or installed. Access to a
network may be denied when the modification itself materially and
adversely affects the operation of the network or violates the rules and
protocols for communication across the network.
Corresponding Source conveyed, and Installation Information provided,
in accord with this section must be in a format that is publicly
documented (and with an implementation available to the public in
source code form), and must require no special password or key for
unpacking, reading or copying.
7. Additional Terms.
"Additional permissions" are terms that supplement the terms of this
License by making exceptions from one or more of its conditions.
Additional permissions that are applicable to the entire Program shall
be treated as though they were included in this License, to the extent
that they are valid under applicable law. If additional permissions
apply only to part of the Program, that part may be used separately
under those permissions, but the entire Program remains governed by
this License without regard to the additional permissions.
When you convey a copy of a covered work, you may at your option
remove any additional permissions from that copy, or from any part of
it. (Additional permissions may be written to require their own
removal in certain cases when you modify the work.) You may place
additional permissions on material, added by you to a covered work,
for which you have or can give appropriate copyright permission.
Notwithstanding any other provision of this License, for material you
add to a covered work, you may (if authorized by the copyright holders of
that material) supplement the terms of this License with terms:
a) Disclaiming warranty or limiting liability differently from the
terms of sections 15 and 16 of this License; or
b) Requiring preservation of specified reasonable legal notices or
author attributions in that material or in the Appropriate Legal
Notices displayed by works containing it; or
c) Prohibiting misrepresentation of the origin of that material, or
requiring that modified versions of such material be marked in
reasonable ways as different from the original version; or
d) Limiting the use for publicity purposes of names of licensors or
authors of the material; or
e) Declining to grant rights under trademark law for use of some
trade names, trademarks, or service marks; or
f) Requiring indemnification of licensors and authors of that
material by anyone who conveys the material (or modified versions of
it) with contractual assumptions of liability to the recipient, for
any liability that these contractual assumptions directly impose on
those licensors and authors.
All other non-permissive additional terms are considered "further
restrictions" within the meaning of section 10. If the Program as you
received it, or any part of it, contains a notice stating that it is
governed by this License along with a term that is a further
restriction, you may remove that term. If a license document contains
a further restriction but permits relicensing or conveying under this
License, you may add to a covered work material governed by the terms
of that license document, provided that the further restriction does
not survive such relicensing or conveying.
If you add terms to a covered work in accord with this section, you
must place, in the relevant source files, a statement of the
additional terms that apply to those files, or a notice indicating
where to find the applicable terms.
Additional terms, permissive or non-permissive, may be stated in the
form of a separately written license, or stated as exceptions;
the above requirements apply either way.
8. Termination.
You may not propagate or modify a covered work except as expressly
provided under this License. Any attempt otherwise to propagate or
modify it is void, and will automatically terminate your rights under
this License (including any patent licenses granted under the third
paragraph of section 11).
However, if you cease all violation of this License, then your
license from a particular copyright holder is reinstated (a)
provisionally, unless and until the copyright holder explicitly and
finally terminates your license, and (b) permanently, if the copyright
holder fails to notify you of the violation by some reasonable means
prior to 60 days after the cessation.
Moreover, your license from a particular copyright holder is
reinstated permanently if the copyright holder notifies you of the
violation by some reasonable means, this is the first time you have
received notice of violation of this License (for any work) from that
copyright holder, and you cure the violation prior to 30 days after
your receipt of the notice.
Termination of your rights under this section does not terminate the
licenses of parties who have received copies or rights from you under
this License. If your rights have been terminated and not permanently
reinstated, you do not qualify to receive new licenses for the same
material under section 10.
9. Acceptance Not Required for Having Copies.
You are not required to accept this License in order to receive or
run a copy of the Program. Ancillary propagation of a covered work
occurring solely as a consequence of using peer-to-peer transmission
to receive a copy likewise does not require acceptance. However,
nothing other than this License grants you permission to propagate or
modify any covered work. These actions infringe copyright if you do
not accept this License. Therefore, by modifying or propagating a
covered work, you indicate your acceptance of this License to do so.
10. Automatic Licensing of Downstream Recipients.
Each time you convey a covered work, the recipient automatically
receives a license from the original licensors, to run, modify and
propagate that work, subject to this License. You are not responsible
for enforcing compliance by third parties with this License.
An "entity transaction" is a transaction transferring control of an
organization, or substantially all assets of one, or subdividing an
organization, or merging organizations. If propagation of a covered
work results from an entity transaction, each party to that
transaction who receives a copy of the work also receives whatever
licenses to the work the party's predecessor in interest had or could
give under the previous paragraph, plus a right to possession of the
Corresponding Source of the work from the predecessor in interest, if
the predecessor has it or can get it with reasonable efforts.
You may not impose any further restrictions on the exercise of the
rights granted or affirmed under this License. For example, you may
not impose a license fee, royalty, or other charge for exercise of
rights granted under this License, and you may not initiate litigation
(including a cross-claim or counterclaim in a lawsuit) alleging that
any patent claim is infringed by making, using, selling, offering for
sale, or importing the Program or any portion of it.
11. Patents.
A "contributor" is a copyright holder who authorizes use under this
License of the Program or a work on which the Program is based. The
work thus licensed is called the contributor's "contributor version".
A contributor's "essential patent claims" are all patent claims
owned or controlled by the contributor, whether already acquired or
hereafter acquired, that would be infringed by some manner, permitted
by this License, of making, using, or selling its contributor version,
but do not include claims that would be infringed only as a
consequence of further modification of the contributor version. For
purposes of this definition, "control" includes the right to grant
patent sublicenses in a manner consistent with the requirements of
this License.
Each contributor grants you a non-exclusive, worldwide, royalty-free
patent license under the contributor's essential patent claims, to
make, use, sell, offer for sale, import and otherwise run, modify and
propagate the contents of its contributor version.
In the following three paragraphs, a "patent license" is any express
agreement or commitment, however denominated, not to enforce a patent
(such as an express permission to practice a patent or covenant not to
sue for patent infringement). To "grant" such a patent license to a
party means to make such an agreement or commitment not to enforce a
patent against the party.
If you convey a covered work, knowingly relying on a patent license,
and the Corresponding Source of the work is not available for anyone
to copy, free of charge and under the terms of this License, through a
publicly available network server or other readily accessible means,
then you must either (1) cause the Corresponding Source to be so
available, or (2) arrange to deprive yourself of the benefit of the
patent license for this particular work, or (3) arrange, in a manner
consistent with the requirements of this License, to extend the patent
license to downstream recipients. "Knowingly relying" means you have
actual knowledge that, but for the patent license, your conveying the
covered work in a country, or your recipient's use of the covered work
in a country, would infringe one or more identifiable patents in that
country that you have reason to believe are valid.
If, pursuant to or in connection with a single transaction or
arrangement, you convey, or propagate by procuring conveyance of, a
covered work, and grant a patent license to some of the parties
receiving the covered work authorizing them to use, propagate, modify
or convey a specific copy of the covered work, then the patent license
you grant is automatically extended to all recipients of the covered
work and works based on it.
A patent license is "discriminatory" if it does not include within
the scope of its coverage, prohibits the exercise of, or is
conditioned on the non-exercise of one or more of the rights that are
specifically granted under this License. You may not convey a covered
work if you are a party to an arrangement with a third party that is
in the business of distributing software, under which you make payment
to the third party based on the extent of your activity of conveying
the work, and under which the third party grants, to any of the
parties who would receive the covered work from you, a discriminatory
patent license (a) in connection with copies of the covered work
conveyed by you (or copies made from those copies), or (b) primarily
for and in connection with specific products or compilations that
contain the covered work, unless you entered into that arrangement,
or that patent license was granted, prior to 28 March 2007.
Nothing in this License shall be construed as excluding or limiting
any implied license or other defenses to infringement that may
otherwise be available to you under applicable patent law.
12. No Surrender of Others' Freedom.
If conditions are imposed on you (whether by court order, agreement or
otherwise) that contradict the conditions of this License, they do not
excuse you from the conditions of this License. If you cannot convey a
covered work so as to satisfy simultaneously your obligations under this
License and any other pertinent obligations, then as a consequence you may
not convey it at all. For example, if you agree to terms that obligate you
to collect a royalty for further conveying from those to whom you convey
the Program, the only way you could satisfy both those terms and this
License would be to refrain entirely from conveying the Program.
13. Use with the GNU Affero General Public License.
Notwithstanding any other provision of this License, you have
permission to link or combine any covered work with a work licensed
under version 3 of the GNU Affero General Public License into a single
combined work, and to convey the resulting work. The terms of this
License will continue to apply to the part which is the covered work,
but the special requirements of the GNU Affero General Public License,
section 13, concerning interaction through a network will apply to the
combination as such.
14. Revised Versions of this License.
The Free Software Foundation may publish revised and/or new versions of
the GNU General Public License from time to time. Such new versions will
be similar in spirit to the present version, but may differ in detail to
address new problems or concerns.
Each version is given a distinguishing version number. If the
Program specifies that a certain numbered version of the GNU General
Public License "or any later version" applies to it, you have the
option of following the terms and conditions either of that numbered
version or of any later version published by the Free Software
Foundation. If the Program does not specify a version number of the
GNU General Public License, you may choose any version ever published
by the Free Software Foundation.
If the Program specifies that a proxy can decide which future
versions of the GNU General Public License can be used, that proxy's
public statement of acceptance of a version permanently authorizes you
to choose that version for the Program.
Later license versions may give you additional or different
permissions. However, no additional obligations are imposed on any
author or copyright holder as a result of your choosing to follow a
later version.
15. Disclaimer of Warranty.
THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY
APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT
HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY
OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM
IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF
ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
16. Limitation of Liability.
IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS
THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY
GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE
USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF
DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD
PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS),
EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGES.
17. Interpretation of Sections 15 and 16.
If the disclaimer of warranty and limitation of liability provided
above cannot be given local legal effect according to their terms,
reviewing courts shall apply local law that most closely approximates
an absolute waiver of all civil liability in connection with the
Program, unless a warranty or assumption of liability accompanies a
copy of the Program in return for a fee.
END OF TERMS AND CONDITIONS
How to Apply These Terms to Your New Programs
If you develop a new program, and you want it to be of the greatest
possible use to the public, the best way to achieve this is to make it
free software which everyone can redistribute and change under these terms.
To do so, attach the following notices to the program. It is safest
to attach them to the start of each source file to most effectively
state the exclusion of warranty; and each file should have at least
the "copyright" line and a pointer to where the full notice is found.
<one line to give the program's name and a brief idea of what it does.>
Copyright (C) <year> <name of author>
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
Also add information on how to contact you by electronic and paper mail.
If the program does terminal interaction, make it output a short
notice like this when it starts in an interactive mode:
<program> Copyright (C) <year> <name of author>
This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
This is free software, and you are welcome to redistribute it
under certain conditions; type `show c' for details.
The hypothetical commands `show w' and `show c' should show the appropriate
parts of the General Public License. Of course, your program's commands
might be different; for a GUI interface, you would use an "about box".
You should also get your employer (if you work as a programmer) or school,
if any, to sign a "copyright disclaimer" for the program, if necessary.
For more information on this, and how to apply and follow the GNU GPL, see
<http://www.gnu.org/licenses/>.
The GNU General Public License does not permit incorporating your program
into proprietary programs. If your program is a subroutine library, you
may consider it more useful to permit linking proprietary applications with
the library. If this is what you want to do, use the GNU Lesser General
Public License instead of this License. But first, please read
<http://www.gnu.org/philosophy/why-not-lgpl.html>.

37
Makefile Normal file
View File

@ -0,0 +1,37 @@
# makedist Makefile for installation and packaging
# Copyright (c) 2003-2007 by Silvan Calarco <silvan.calarco@mambasoft.it>
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.
include makedist/VERSION
package = makedist
distdir = $(package)-$(makedist_version)
dist_archive = $(package)-$(makedist_version).tar.bz2
prefix := /usr
datadir := $(prefix)/share
sysconfdir := /etc
dist: clean
@tar cf - --exclude=$(dist_archive) --exclude=global/defs.inc \
--exclude global/distromatic.conf -C .. $(distdir) | \
bzip2 -9 -c > $(dist_archive)
@echo "file \`$(dist_archive)' created"
dist-rpm: dist
@rpm_sourcedir=`rpm --eval=%{_sourcedir}`;\
mv -f $(package)-$(makedist_version).tar.bz2 $$rpm_sourcedir;\
echo "and saved as \`$$rpm_sourcedir/$(dist_archive)'"
clean:
@rm -fr $(dist_archive)
install:
@install -d $(DESTDIR)$(datadir);\
cp -a makedist $(DESTDIR)$(datadir)/;\
install -d $(DESTDIR)$(sysconfdir)/makedist;\
cp -a config/config $(DESTDIR)$(sysconfdir)/makedist/config

19
config/config Normal file
View File

@ -0,0 +1,19 @@
#
# makedist global configuration file
#
# Copyright (c) by Silvan Calarco <silvan.calarco@mambasoft.it>
#
DISTRONAME="openmamba"
PORT_FROM_ARCH="i586"
PORT_DEST_REPOSITORY="devel"
PORT_AUTODIST_USER="silvan"
RPM_GPG_KEY=/etc/pki/rpm-gpg/RPM-GPG-KEY-Mambasoft
REPOSITORY=(
/var/ftp/pub/openmamba/devel
/var/ftp/pub/openmamba/devel-games
/var/ftp/pub/openmamba/devel-makedist
/var/ftp/private/openmamba/private
)
ADDITIONAL_DEFS_FILE="/usr/share/openmamba/pkggroups.db"

48
makedist/Makefile Normal file
View File

@ -0,0 +1,48 @@
# makedist Makefile
# Copyright (c) 2003-2004 by Davide Madrisan <davide.madrisan@gmail.com>
# Copyright (c) 2003-2011 by Silvan Calarco <silvan.calarco@mambasoft.it>
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.
include /var/makedist/.defs.inc
include ./VERSION
default_branch = devel
ftp_path = ftp://ftp.openmamba.org/pub/openmamba
# FIXME: obsolete, check and remove next time
initrd_dir = $(LOCALSTATEDIR)/initrd
ALL_TARGETS = $(shell ls $(TARGETSDIR))
DEBUG := 0
help:
@echo;\
echo "makedist Makefile help, version $(makedist_version) " \
| sed -e :l -e 's/^.\{1,71\}$$/&_/;t l';\
echo ;\
echo " make <target> create distribution for <target>";\
echo " make clean remove the intermediate files except ISO, RPM";\
echo " make help display this help";\
echo;\
echo " You can also set the above variables:";\
echo " - \`DEBUG': if set to 1 enables debugging features (target dependent)";\
echo " - \`PLATFORM: specify the target platform (eg. free,desktop,server)";\
echo;\
echo " e.g. make openmamba PLATFORM=flash-1GB";\
echo;\
echo;\
echo "WARNING: this Makefile shouldn't be called directly by the user.";\
echo " Please use the makedist instead; type \`makedist\` for help.";\
echo
$(ALL_TARGETS): clean
@branch=$(BRANCH); test -z "$$branch" && branch=$(default_branch);\
./makedist.sh -t $@ $(initrd_dir) $$branch $(DEBUG)
clean:
@rm -fr $(initrd_dir)/modules/* $(initrd_dir)/install/* || true

1
makedist/VERSION Normal file
View File

@ -0,0 +1 @@
makedist_version=2.3

200
makedist/defs.inc.sh Normal file
View File

@ -0,0 +1,200 @@
#
# makedist definitions include script
#
# Copyright (c) 2007-2011 by Silvan Calarco <silvan.calarco@mambasoft.it>
#
PASSED_TARGET=$1
PASSED_PLATFORM=$2
PASSED_SUBPLATFORM=$3
PASSED_ARCH=$4
PASSED_KERNEL_EXTRAVER=$5
PASSED_DISTROMATIC=$6
PASSED_RELEASE=$7
PASSED_VARIANT=$8
#RPM=rpm
#RPM2CPIO=rpm2cpio
TOPDIR=/usr/share/makedist
CONFIGFILE=/etc/makedist/config
# NOTE: LOCALSTATEDIR is hardcoded in Makefile and global/Makefile, to change it you have to modify there files too
LOCALSTATEDIR=/var/makedist
SOURCEDIR=$LOCALSTATEDIR/repositories
TARGETSDIR=$LOCALSTATEDIR/targets
# load some target specific settings
if [ "$PASSED_TARGET" ]; then
[ -r $TARGETSDIR/$PASSED_TARGET/settings.inc ] || {
echo "Error: missing target file $TARGETSDIR/$PASSED_TARGET/settings.inc; aborting."
exit 1
}
PLATFORM=$PASSED_PLATFORM \
TARGETDIR=$TARGETSDIR/$PASSED_TARGET \
. $TARGETSDIR/$PASSED_TARGET/settings.inc
fi
[ "$PASSED_RELEASE" ] && RELEASE=$PASSED_RELEASE
[ "$PASSED_VARIANT" ] && VARIANT=$PASSED_VARIANT
if [ "$PASSED_ARCH" ]; then
ARCH=$PASSED_ARCH
fi
arch=$ARCH
[ $ARCH ] || {
arch=`uname -i`
[ "$arch" = "unknown" ] && {
echo "Error: can't determine the hardware platform; aborting."
exit 1
}
}
case $arch in
i386|i486|i686) arch=i586 ; ARCH=i586 ;;
esac
if [ "$arch" = "x86_64" ]; then
arch_fallback=i586
fi
if [ "$PASSED_KERNEL_EXTRAVER" ]; then
KERNEL_EXTRAVER=$PASSED_KERNEL_EXTRAVER
fi
if [ "$PASSED_DISTROMATIC" ]; then
PASSED_DISTROMATIC=$PASSED_DISTROMATIC
fi
. $TOPDIR/VERSION
. $CONFIGFILE
[ "$PASSED_TARGET" ] && {
[ -r $CONFIGFILE-$PASSED_TARGET ] && . $CONFIGFILE-$PASSED_TARGET
[ "$PASSED_PLATFORM" ] && {
[ -r $CONFIGFILE-$PASSED_TARGET-$PASSED_PLATFORM ] &&
. $CONFIGFILE-$PASSED_TARGET-$PASSED_PLATFORM
}
}
[ "${REPOSITORY[*]}" ] || {
echo "Error: no repositories defined in configuration file; aborting."
exit 1
}
# NOTE: repository paths must end with "/"
for c in `seq 1 ${#REPOSITORY[*]}`; do
[ ${REPOSITORY[$c-1]: -1} = "/" ] ||
REPOSITORY[$c-1]=${REPOSITORY[$c-1]}/
RPMDIR[$c-1]=${REPOSITORY[$c-1]}RPMS.
SRPMDIR[$c-1]=${REPOSITORY[$c-1]}SRPMS.base/
done
UTILSDIR=$LOCALSTATEDIR/utils
GLOBALDIR=$TOPDIR/global
MEDIA_LIST="cd1 cd2 cd3 cd4 dvd1"
DEPSFILE=$LOCALSTATEDIR/distromatic/deps
BUILDDEPSFILE=$LOCALSTATEDIR/distromatic/builddeps
SOURCESFILE=$LOCALSTATEDIR/distromatic/sources
BUILDSFILE=$LOCALSTATEDIR/distromatic/builds
if [ "$BUILD_MISSING" -a "$BUILD_MISSING" != "0" -a "$arch" != "$PORT_FROM_ARCH" ]; then
DISTROMATIC_ARCHS="$PORT_FROM_ARCH $arch"
else
DISTROMATIC_ARCHS="$arch"
fi
cat > $LOCALSTATEDIR/distromatic/distromatic.conf << _EOF
#
# distromatic.conf: distromatic configuration file for use with makedist
#
# this file was autogenerated by defs.inc.sh, please do not modify this file
# but look in defs.inc.sh.
#
[defaults]
HTML_BASEDIR = $LOCALSTATEDIR/
DISTRIBUTION_NAME = ${DISTRONAME}
ARCHS = $DISTROMATIC_ARCHS
_EOF
ALTREPNUM=`expr ${#REPOSITORY[*]} - 2`
for c in `seq 0 $ALTREPNUM`; do
echo "
[makedist${c}]
DESCRIPTION = makedsit repository ${c}
REPOSITORY_DIR = ${REPOSITORY[$c]}" >> $LOCALSTATEDIR/distromatic/distromatic.conf
done
cat >> $LOCALSTATEDIR/distromatic/distromatic.conf << _EOF
[distromatic]
DESCRIPTION = makedist repository
REPOSITORY_DIR = ${REPOSITORY[${#REPOSITORY[*]}-1]}
_EOF
for c in `seq 0 $ALTREPNUM`; do
echo "PARENT = makedist${c}" >> $LOCALSTATEDIR/distromatic/distromatic.conf
done
cat > $LOCALSTATEDIR/.defs.inc << _EOF
#
# .defs.inc: include file for global Makefile
#
# this file was autogenerated by defs.inc.sh, please do not modify this file
# but look in defs.inc.sh.
#
DISTRONAME=$DISTRONAME
RELEASE=$RELEASE
VARIANT=$VARIANT
LOCALSTATEDIR=$LOCALSTATEDIR
SOURCEDIR=$SOURCEDIR
TOPDIR=$TOPDIR
TARGETSDIR=$TARGETSDIR
RPMDIR=$RPMDIR
SRPMDIR=$SRPMDIR
DISTROMATIC_URL_PREFIX="$DISTROMATIC_URL_PREFIX"
DEPSFILE=$DEPSFILE
BUILDDEPSFILE=$BUILDDEPSFILE
SOURCESFILE=$SOURCESFILE
BUILDSFILE=$BUILDSFILE
UTILSDIR=$UTILSDIR
GLOBALDIR=$GLOBALDIR
MEDIA_LIST="$MEDIA_LIST"
makedist_version=$makedist_version
MAKEDIST_TARGET=$PASSED_TARGET
arch=$arch
arch_fallback=$arch_fallback
ARCH=$arch
PORT_FROM_ARCH=$PORT_FROM_ARCH
PORT_DEST_REPOSITORY=$PORT_DEST_REPOSITORY
PORT_AUTODIST_USER=$PORT_AUTODIST_USER
KERNEL_EXTRAVER=$KERNEL_EXTRAVER
PASSED_DISTROMATIC=$PASSED_DISTROMATIC
PASSED_RELEASE=$PASSED_RELEASE
PASSED_VARIANT=$PASSED_VARIANT
RPM_GPG_KEY=$RPM_GPG_KEY
_EOF
for c in `seq 1 ${#REPOSITORY[*]}`; do
echo "\
REPOSITORY[$c-1]=${REPOSITORY[$c-1]}
RPMDIR[$c-1]=${RPMDIR[$c-1]}
SRPMDIR[$c-1]=${SRPMDIR[$c-1]}
" >> $LOCALSTATEDIR/.defs.inc
done
> $LOCALSTATEDIR/.Makefile.inc
[ -e ${ADDITIONAL_DEFS_FILE} ] && {
. ${ADDITIONAL_DEFS_FILE}
cat ${ADDITIONAL_DEFS_FILE} | \
while read line; do
if [[ "$line" =~ ([A-Z0-9_]*)= ]]; then
echo "${BASH_REMATCH[1]}: ${!BASH_REMATCH[1]}" >> $LOCALSTATEDIR/.Makefile.inc
fi
done
}

1052
makedist/functions.inc.sh Normal file

File diff suppressed because it is too large Load Diff

68
makedist/global/Makefile Normal file
View File

@ -0,0 +1,68 @@
#
# Main Makefile for makedist build scripts
#
include /var/makedist/.defs.inc
include /var/makedist/.Makefile.inc
default:
@echo "Error: no target specified."
ifdef VARSFILE
include $(VARSFILE)
endif
ifndef SOURCESMODE
ifndef BUILDSMODE
#
# deps operation mode
#
ifdef TARGET
include $(TARGETSDIR)/$(TARGET)/Makefile.defs
endif
include $(DEPSFILE)-$(ARCH)
RPMDIR =
INSTALLED =
$(ALL_PACKAGES):
@[ `echo " $$INSTALLED " | grep -c " $@ "` -eq 0 ] && \
echo -n "$@ " || :
all_packages: $(ALL_PACKAGES)
#include Makefile.globdefs
ifdef TARGET
include $(TARGETSDIR)/$(TARGET)/Makefile
endif
endif
endif
ifdef SOURCESMODE
#
# find sources operation mode
#
include $(SOURCESFILE)-$(ARCH)
$(ALL_SOURCES):
@A=$@; echo -n "$${A/_} "
# FIXME: using PORT_FROM_ARCH because sources have build deps that might be missing in target arch
#include $(SOURCESFILE)-$(PORT_FROM_ARCH)
#$(ALL_SOURCES):
# echo -n "$@ " || :
#include $(SOURCESFILE)-$(ARCH)
#$(MISSING_SOURCES):
# echo -n "$@ " || :
endif
ifdef BUILDSMODE
#
# find sources operation mode
#
# FIXME: using PORT_FROM_ARCH because sources have build deps that might be missing in target arch
include $(BUILDSFILE)-$(ARCH)
$(ALL_BUILDS):
echo -n "$@ " || :
endif

View File

@ -0,0 +1,15 @@
#
# Makefile for makedist targets
#
# this file contains common targets for QiLinux base system (e.g. live system boot needed stuff)
#
system-base: filesystem libncurses bash glibc setup qilinux-utils cracklib cracklib-dicts pam \
pwdutils liblockdev rootfiles libgcc gawk ncurses coreutils less psutils perl libdb3 sed flex \
ncurses-dialog binutils libbinutils gettext findutils net-tools m4 file libtool bin86 bzip2 libbzip2 kbd libz \
diffutils e2fsprogs libe2fs jfsutils grep gzip make module-init-tools iputils patch procinfo procps psmisc \
sysvinit initscripts tar util-linux timezone vim cpio rpm rpm-build chkconfig reiserfsprogs expect \
raidtools debianutils cloop ifrename apt parted parted-python
system-network: telnet ftp dhcp-common dhcp-client
system-hardware: pciutils usbutils pcmcia-utils udev ivman hotplug gpm msysklogd
system-tools: mc openssl openssh wget openssh-client traceroute eject cdrtools setserial bootsplash gpart testdisk x86info
system-debug: gdb valgrind strace openssh-client

View File

@ -0,0 +1,66 @@
#
# Makefile.globdefs - global distribution definitions for packages
#
# Copyright (c) 2007 by Silvan Calarco <silvan.calarco@mambasoft.it>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# WARNING: this file is obsolete and not used any longer. It will be removed in future.
#
ifndef LISTALLPACKAGES
kdelibs:
@[ `echo " $$INSTALLED " | grep -c " $@ "` -eq 0 ] && \
{ echo -n "$@ "; \
[ ! "$(LANGUAGE)" = "" ] && [ ! "$(LANGUAGE)" = "en" ] && echo -n "kde-i18n-$(LANGUAGE) "; } || \
:
koffice:
@[ `echo " $$INSTALLED " | grep -c " $@ "` -eq 0 ] && \
{ echo -n "$@ "; \
[ ! "$(LANGUAGE)" = "" ] && [ ! "$(LANGUAGE)" = "en" ] && echo -n "koffice-i18n-$(LANGUAGE) "; } || \
:
k3b:
@[ `echo " $$INSTALLED " | grep -c " $@ "` -eq 0 ] && \
{ echo -n "$@ "; \
[ ! "$(LANGUAGE)" = "" ] && [ ! "$(LANGUAGE)" = "en" ] && echo -n "k3b-i18n-$(LANGUAGE) "; } || \
:
aspell:
@[ `echo " $$INSTALLED " | grep -c " $@ "` -eq 0 ] && \
{ echo -n "$@ "; \
[ ! "$(LANGUAGE)" = "" ] && echo -n "aspell-$(LANGUAGE) "; } || \
:
OpenOffice:
@[ `echo " $$INSTALLED " | grep -c " $@ "` -eq 0 ] && \
{ echo -n "$@ "; \
[ ! "$(LANGUAGE)" = "" ] && [ ! "$(LANGUAGE)" = "en" ] && \
echo -n "OpenOffice-i18n-$(LANGUAGE) "; } || \
echo -n "OpenOffice-i18n-en "
OpenOffice-help:
@[ `echo " $$INSTALLED " | grep -c " $@ "` -eq 0 ] && \
{ echo -n "$@ "; \
[ ! "$(LANGUAGE)" = "" ] && [ ! "$(LANGUAGE)" = "en" ] && \
echo -n "OpenOffice-help-$(LANGUAGE) "; } || \
echo -n "OpenOffice-help-en "
#firefox:
# @[ `echo " $$INSTALLED " | grep -c " $@ "` -eq 0 ] && \
# { echo -n "$@ "; \
# [ ! "$(LANGUAGE)" = "" ] && [ ! "$(LANGUAGE)" = "en" ] && echo -n "firefox-i18n-$(LANGUAGE) "; } || \
# :
endif
kde-i18n-all: kde-i18n-it kde-i18n-fr kde-i18n-de kde-i18n-es
koffice-i18n-all: koffice-i18n-it koffice-i18n-fr koffice-i18n-de koffice-i18n-es
k3b-i18n-all: k3b-i18n-it k3b-i18n-fr k3b-i18n-de k3b-i18n-es
aspell-i18n-all: aspell-en aspell-it aspell-fr aspell-de aspell-es
OpenOffice-all: OpenOffice-i18n-it OpenOffice-help-it OpenOffice-i18n-en OpenOffice-help-en OpenOffice-i18n-fr OpenOffice-help-fr \
OpenOffice-i18n-de OpenOffice-help-de OpenOffice-i18n-es OpenOffice-help-es
firefox-i18n-all: firefox-i18n-it firefox-i18n-fr firefox-i18n-de firefox-i18n-es-ES
kile-i18n-all: kile-i18n-it kile-i18n-fr kile-i18n-es
amarok-i18n-all: amarok-i18n-it amarok-i18n-fr amarok-i18n-de
kernel-mamba-all: kernel-mamba kernel-mamba-extramodules kernel-mamba-nongpl-nvidia kernel-mamba-nongpl-fglrx
kernel-all: kernel-mamba-all
kernelsource: kernel-mamba-source

75
makedist/makedist Executable file
View File

@ -0,0 +1,75 @@
#!/bin/bash
# makedist - main program
# Copyright (c) 2007-2011 by Silvan Calarco <silvan.calarco@mambasoft.it>
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
# PARTICULAR PURPOSE.
#
makedist_me="${0##*/}"
MAKEDIST_DIR=/usr/share/makedist
MAKEDIST_DEFS=$MAKEDIST_DIR/defs.inc.sh
[ -e $MAKEDIST_DIR ] || {
echo "Error: missing makedist directory $MAKEDIST_DIR."
echo "Please check your installation; aborting."
exit 1
}
[ -e $MAKEDIST_DIR/defs.inc.sh ] || {
echo "Error: missing makedist definitions file $MAKEDIST_DEFS."
echo "Please check your installation; aborting."
exit 1
}
opts=($@)
while test -n "$1" ; do
case $1 in
PLATFORM=*) eval $1 ;;
SUBPLATFORM=*) eval $1 ;;
ARCH=*) eval $1 ;;
KERNEL_EXTRAVER=*) eval $1 ;;
DISTROMATIC=*) eval $1 ;;
RELEASE=*) eval $1 ;;
VARIANT=*) eval $1 ;;
*) [ -z "$TARGET" ] && TARGET=$1 ;;
esac
shift
done
. $MAKEDIST_DIR/defs.inc.sh "$TARGET" "$PLATFORM" "$SUBPLATFORM" "$ARCH" "$KERNEL_EXTRAVER" "$DISTROMATIC" "$RELEASE" "$VARIANT"
copyleft="\
makedist media (CD/DVD/Images) creator for RPM based distributions
version $makedist_version
Copyright (c) 2003-2011 by Silvan Calarco <silvan.calarco@mambasoft.it>
Copyright (c) 2003-2005 by Davide Madrisan <davide.madrisan@gmail.com>
"
echo "$copyleft"
function usage() {
echo "\
usage: $makedist_me target [VAR=value]...
Supported variables:
PLATFORM=<platform> : final media platform (e.g. livecd)
SUBPLATFORM=<subplatform> : intermediate platform used by final media platform (e.g. livecd-root)
VARIANT=<variant> : platform variant
RELEASE=<release> : target release
DEBUG=<debuglevel> : debug level
DISTROMATIC=off : disable distromatic
VERBOSE=<level> : level of verbosity
LANGUAGE=<lang> : target language
ARCH=<arch> : target arch
KERNEL_EXTRAVER=<target> : kernel target
Available targets:
`ls $TARGETSDIR`
" >&2
}
[ "$TARGET" ] || { usage; exit 1; }
make --no-print-directory -C $MAKEDIST_DIR ${opts[*]}

455
makedist/makedist.sh Executable file
View File

@ -0,0 +1,455 @@
#
# makedist.sh - Distribution media (CD/DVD/..) creator
#
# Copyright (c) 2003-2011 by Silvan Calarco <silvan.calarco@mambasoft.it>
# Copyright (c) 2003-2006 by Davide Madrisan <davide.madrisan@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
. ./VERSION
. ./functions.inc.sh
. /var/makedist/.defs.inc
copyleft="\
makedist media (CD/DVD/Images) creator (version $makedist_version)
Copyright (c) 2003-2010 by Silvan Calarco <silvan.calarco@mambasoft.it>
Copyright (c) 2003-2005 by Davide Madrisan <davide.madrisan@gmail.com>
"
unset branch # can be 'stable', 'unstable', or 'devel'
makedist_me="${0##*/}"
UPDATE=none
unset KERNEL_VER
INTERACTIVE=false
PUREUPDATE=false
CDNUM=1
RPM=rpm
RPM2CPIO=rpm2cpio
function usage() {
echo "\
usage: $makedist_me [-y] [-u[=<opts>]] [-t target] bootcd initrd kernel branch
-y : switch to non interactive mode
-w : download only files and packages; do not create an ISO image
-t : build CD for specified target
netcd : build an ISO image for installation from network only
livecd: create the ISO image for $DISTRONAME live CD
i.e. $makedist_me -u SOURCE bootcd initrd stable
$makedist_me SOURCE bootcd initrd stable
$makedist_me -w -u SOURCE bootcd initrd devel
" >&2
}
# the following is the default in case of update and other non-target commands
MAKEDIST_TARGET=distrocd
while test -n "$1" ; do
case $1 in
-y) INTERACTIVE=false ;;
-w) PUREUPDATE=true ;;
-t) shift
MAKEDIST_TARGET=$1
[ -d $TARGETSDIR/$1 ] || {
echo "$makedist_me: unknown target '$1'"; exit 1
}
;;
-h) usage; exit ;;
-v) echo "$copyleft"; exit ;;
*) if test -z "$INITRDDIR" ; then INITRDDIR=$1
elif test -z "$branch" ; then branch=$1
elif test -z "$DEBUG" ; then DEBUG=$1
elif test -z "$MEDIA" ; then MEDIA=$1
elif test -z "$PLATFORM" ; then PLATFORM=$1
elif test -z "$LANGUAGE" ; then LANGUAGE=$1
fi ;;
esac
shift
done
#test $UID = 0 ||
# { echo "$makedist_me: must be superuser." >&2
# { (exit 1); exit 1; }; }
unset error
test -z "$INITRDDIR" && error=true
test "$UPDATE" != "none" -a -z "$branch" && error=true
test x$error = xtrue &&
{ echo "$makedist_me: missing parameter";
usage; { (exit 1); exit 1; }; }
case "$branch" in
stable) branch_dir="stable/current" ;;
unstable) branch_dir="unstable/current" ;;
devel) branch_dir="devel" ;;
*) echo "unknown branch ($branch)"
echo "valid choices are: 'stable', 'unstable', 'devel'"
exit 1 ;;
esac
case "$LANGUAGE" in
it*) LANGUAGE=it
COUNTRY=IT ;;
en*) LANGUAGE=en
COUNTRY=US ;;
es*) LANGUAGE=es
COUNTRY=ES ;;
fr*) LANGUAGE=fr
COUNTRY=FR ;;
"") LANGUAGE=en
COUNTRY=US ;;
*) echo "Unsupported language: $LANGUAGE; aborting."
exit 1
;;
esac
TARGETDIR=$TARGETSDIR/$MAKEDIST_TARGET
MOUNTDIR=$LOCALSTATEDIR/root.tmp
# Auxiliary mountdir
MOUNTDIR2=$LOCALSTATEDIR/root2.tmp
[ -d $MOUNTDIR ] && rm -rf $MOUNTDIR
mkdir -p $MOUNTDIR
[ -d $MOUNTDIR2 ] && rm -rf $MOUNTDIR2
mkdir -p $MOUNTDIR2
MOUNTFS=$LOCALSTATEDIR/rootfs.tmp
CHROOTCMD="chroot $MOUNTDIR"
# boot kernel is the SMP one
#KERNEL_EXTRAVER=smp
# note: some non-SMP machines are unable to boot with a SMP kernel
KERNEL_EXTRAVER=
# set BUILDARCH
BUILDARCH=`uname -m`
case $BUILDARCH in
i386|i486|i586|i686|athlon) BUILDARCH=i586 ;;
arm*) BUILDARCH=arm ;;
*) echo "Error: build architecture $BUILDARCH is unknown; aborting."
exit 1
;;
esac
#
# load some target specific settings
. $TARGETDIR/settings.inc
# default media is cd1
[ "$MEDIA" ] || MEDIA=cd1
if [ "$DISTRIBUTION" = "1" ]; then
DISKTAG=$PLATFORM-$MEDIA
else
DISKTAG=$MAKEDIST_TARGET
fi
ISOLINUXDIR=$MOUNTDIR2/isolinux
INITRD=$MOUNTDIR2/isolinux/initrd
FSIMAGE=$MOUNTDIR2/rootfs.img
COMPRESSEDIMAGE=$MOUNTDIR2/rootfs.compressed
COMPRESSEDFSSIZE=300000
COMPRESSEDFSBLOCKSIZE=1k
[ "$PASSED_RELEASE" ] && RELEASE=$PASSED_RELEASE
[ "$PASSED_DISTROMATIC" ] && DISTROMATIC=$PASSED_DISTROMATIC
[ "$PASSED_VARIANT" ] && VARIANT=$PASSED_VARIANT
echo "\
Configuration:
- distribution : $DISTRONAME
- target : $MAKEDIST_TARGET
- platform : $PLATFORM ($MAKEDIST_TARGET/platforms/$PLATFORM)
- variant : $VARIANT
- release : $RELEASE
- target media : $MEDIA
- target arch : $arch
- distromatic : $PASSED_DISTROMATIC"
[ "$arch_fallback" ] && echo "\
- fallback arch : $arch_fallback"
echo "\
- language : $LANGUAGE
- country : $COUNTRY
Repositories:"
for r in ${REPOSITORY[*]}; do
echo " - $r"
done
echo
# - utils directory : $UTILSDIR
# - initrd directory: $INITRDDIR
# - deps file : $DEPSFILE-$arch
# - auxiliary tmpdir: $MOUNTDIR2
#KERNEL_VER=`get_rpm_version kernel`
if [ ! "$KERNEL_IGNORE" ]; then
[ "$KERNEL_EXTRAVER" ] &&
KERNEL_VER=`get_rpm_version kernel-${KERNEL_EXTRAVER}${KERNEL_PLATFORM}` ||
{
echo "Error: undefined KERNEL_EXTRAVER! Aborting."; exit 1;
}
test -n "$KERNEL_VER" ||
{ echo "$makedist_me: cannot get KERNEL_VER" >&2
{ (exit 1); exit 1; }; }
echo "Found Linux kernel version ${KERNEL_VER}${KERNEL_EXTRAVER}"
KERNEL_MAJVER=`echo $KERNEL_VER | cut -d. -f1-3`
echo "
KERNEL_PLATFORM=${KERNEL_PLATFORM}
KERNEL_EXTRAVER=${KERNEL_EXTRAVER}" >> /var/makedist/.defs.inc
else
echo "Skipping kernel check"
fi
# remove CVS entries from utilsdir
find $UTILSDIR -name CVS -type d -print | xargs rm -rf
# Updating .mo files (i18n support)
[ -e $UTILSDIR/po ] && {
echo "Updating i18n files..."
languages="`find $UTILSDIR/po -mindepth 1 -maxdepth 1 -type d \
-path '*/CVS' -prune -o -print | sed -n 's/.*\///p'`"
echo "Checking for catalogs... $languages"
for language in $languages; do
rm -f $UTILSDIR/locale/$language/LC_MESSAGES/*
let i=0
for pof in `find $UTILSDIR/po/$language -name *.po -printf "%f "`; do
mof="`echo $pof | sed 's/\(.*\).po/\1.mo/'`"
msgfmt -o $UTILSDIR/locale/$language/LC_MESSAGES/$mof \
$UTILSDIR/po/$language/$pof || exit 1
let i+=1
done
echo " - Updated i18n files ($i files) for language $language..."
done
}
# execute distromatic
[ "$DISTROMATIC" != "off" ] && exec_distromatic
function create_filesystem() {
# NOTE: this function is currently unmaintained
#
# create the filesystem
#
# parameters:
#
# $1: filesystem size
# $2: block size
# $3: filesystem type (defaults to ext2)
[ "$3" ] && FS=$3 || FS=ext2
echo "Creating $FS filesystem ($MOUNTFS)..."
umount /dev/loop2 2>/dev/null # FIXME
rm -f $FSIMAGE
losetup -d /dev/loop2 2>/dev/null
test -d $MOUNTFS || mkdir -p $MOUNTFS
dd if=/dev/zero of=$FSIMAGE bs=$2 count=$1
losetup /dev/loop2 $FSIMAGE
mkfs -t $FS -m 0 /dev/loop2 > /dev/null
mount /dev/loop2 $MOUNTFS || exit 1
}
function create_raw_filesystem() {
# create a raw filesystem
#
# parameters:
#
# $1: filesystem image name
# $2: filesystem size
# $3: block size
# $4: filesystem type (defaults to ext2)
[ "$1" -a "$2" -a "$3" ] || {
echo "create_raw_filesystem: invalid number of parameters; aborting."
exit 1;
}
[ "$4" ] && FS=$4 || FS=ext2
echo "Creating $FS filesystem ($1)..."
umount /dev/loop2 2>/dev/null # FIXME
rm -f $FSIMAGE
losetup -d /dev/loop2 2>/dev/null
dd if=/dev/zero of=$1 bs=$3 count=$2
losetup /dev/loop2 $1
mkfs -t $FS -m 0 /dev/loop2 > /dev/null
mount /dev/loop2 $MOUNTDIR || exit 1
}
function create_raw_disk_image() {
# create a raw disk image
#
# parameters:
#
# $1: disk image filename
# $2: disk size (MBytes)
# $3: block size
# $4: filesystem type (defaults to ext2)
[ "$1" -a "$2" -a "$3" ] || {
echo "create_raw_disk_image: invalid number of parameters; aborting."